//import meter library
import meter.*;
//import serial library
import processing.serial.*;

Serial port;// define a port

Meter m, m2, m3, m4, m5, m6;

void setup(){
  //create a window
  size(1300, 1000);
  background(0, 0, 0); //color of window
  //create a new port
  port = new Serial(this,"COM5", 9600);
  //default meter to empty window
  m = new Meter(this, 80, 30); //coordinates
  m.setMeterWidth(380);//Important!! if changing the size of the meter, make that the first change
  
  m.setTitleFontSize(20);
  m.setTitleFontName("Times new roman bold");
  m.setTitle("Temperature °C");
 
  
  //change meter scale values
  String[] scaleLabels = {"0", "10", "20", "30", "40", "50", "60", "70", "80"};
  m.setScaleLabels(scaleLabels);
  m.setScaleFontSize(15);
  m.setScaleFontColor(color(25, 25, 200));
  
  //the real value of the meter
  m.setDisplayDigitalMeterValue(true);
  
  //Lets do some more modifications so our meter looks nice
  m.setArcColor(color(204, 0, 0));
  m.setArcThickness(10);
  
  m.setMaxScaleValue(80);
  
  m.setMinInputSignal(0);
  m.setMaxInputSignal(80);
  m.setNeedleThickness(2);
  
  //humidity meter
  int mx = m.getMeterX(); //x coordinate of m
  int my = m.getMeterY();//y coordinate of m
  int mw = m.getMeterWidth();
  
  m2 = new Meter(this, mx + mw +50, my);
  m2.setMeterWidth(380);//Important!! if changing the size of the meter, make that the first change
  
  m2.setTitleFontSize(20);
  m2.setTitleFontName("Times new roman bold");
  m2.setTitle("Humidity (%)");
  
  
  //change meter scale values
  String[] scaleLabels2 = {"0", "10", "20", "30", "40", "50", "60", "70", "80", "90", "100"};
  m2.setScaleLabels(scaleLabels2);
  m2.setScaleFontSize(15);
  m2.setScaleFontColor(color(25, 25, 200));
  
  //the real value of the meter
  m2.setDisplayDigitalMeterValue(true);
  
  //Lets do some more modifications so our meter looks nice
  m2.setArcColor(color(176, 196, 222));
  m2.setArcThickness(10);
  
  m2.setMaxScaleValue(100);
  
  m2.setMinInputSignal(0);
  m2.setMaxInputSignal(100);
  m2.setNeedleThickness(2);
  
  //m3
  
  m3 = new Meter(this, 80, 290); //coordinates
  m3.setMeterWidth(380);//Important!! if changing the size of the meter, make that the first change
  
  m3.setTitleFontSize(20);
  m3.setTitleFontName("Times new roman bold");
  m3.setTitle("Temperature °C");
 
  
  //change meter scale values
  String[] scaleLabels3 = {"0", "10", "20", "30", "40", "50", "60", "70", "80"};
  m3.setScaleLabels(scaleLabels3);
  m3.setScaleFontSize(15);
  m3.setScaleFontColor(color(25, 25, 200));
  
  //the real value of the meter
  m3.setDisplayDigitalMeterValue(true);
  
  //Lets do some more modifications so our meter looks nice
  m3.setArcColor(color(204, 0, 0));
  m3.setArcThickness(10);
  
  m3.setMaxScaleValue(80);
  
  m3.setMinInputSignal(0);
  m3.setMaxInputSignal(80);
  m3.setNeedleThickness(2);
  
  //m4
  
  int m3x = m3.getMeterX(); //x coordinate of m
  int m3y = m3.getMeterY();//y coordinate of m
  int m3w = m3.getMeterWidth();
  
  m4 = new Meter(this, m3x + m3w +50, m3y);
  m4.setMeterWidth(380);//Important!! if changing the size of the meter, make that the first change
  
  m4.setTitleFontSize(20);
  m4.setTitleFontName("Times new roman bold");
  m4.setTitle("Humidity (%)");
  
  
  //change meter scale values
  String[] scaleLabels4 = {"0", "10", "20", "30", "40", "50", "60", "70", "80", "90", "100"};
  m4.setScaleLabels(scaleLabels4);
  m4.setScaleFontSize(15);
  m4.setScaleFontColor(color(25, 25, 200));
  
  //the real value of the meter
  m4.setDisplayDigitalMeterValue(true);
  
  //Lets do some more modifications so our meter looks nice
  m4.setArcColor(color(176, 196, 222));
  m4.setArcThickness(10);
  
  m4.setMaxScaleValue(100);
  
  m4.setMinInputSignal(0);
  m4.setMaxInputSignal(100);
  m4.setNeedleThickness(2);
  
  //m5
  
  m5 = new Meter(this, 80, 550); //coordinates
  m5.setMeterWidth(380);//Important!! if changing the size of the meter, make that the first change
  
  m5.setTitleFontSize(20);
  m5.setTitleFontName("Times new roman bold");
  m5.setTitle("Temperature °C");
 
  
  //change meter scale values
  String[] scaleLabels5 = {"0", "10", "20", "30", "40", "50", "60", "70", "80"};
  m5.setScaleLabels(scaleLabels5);
  m5.setScaleFontSize(15);
  m5.setScaleFontColor(color(25, 25, 200));
  
  //the real value of the meter
  m5.setDisplayDigitalMeterValue(true);
  
  //Lets do some more modifications so our meter looks nice
  m5.setArcColor(color(204, 0, 0));
  m5.setArcThickness(10);
  
  m5.setMaxScaleValue(80);
  
  m5.setMinInputSignal(0);
  m5.setMaxInputSignal(80);
  m5.setNeedleThickness(2);
  
  //m6
  
  int m5x = m5.getMeterX(); //x coordinate of m
  int m5y = m5.getMeterY();//y coordinate of m
  int m5w = m5.getMeterWidth();
  
  m6 = new Meter(this, m5x + m5w +50, m5y);
  m6.setMeterWidth(380);//Important!! if changing the size of the meter, make that the first change
  
  m6.setTitleFontSize(20);
  m6.setTitleFontName("Times new roman bold");
  m6.setTitle("Humidity (%)");
  
  
  //change meter scale values
  String[] scaleLabels6 = {"0", "10", "20", "30", "40", "50", "60", "70", "80", "90", "100"};
  m6.setScaleLabels(scaleLabels6);
  m6.setScaleFontSize(15);
  m6.setScaleFontColor(color(25, 25, 200));
  
  //the real value of the meter
  m6.setDisplayDigitalMeterValue(true);
  
  //Lets do some more modifications so our meter looks nice
  m6.setArcColor(color(176, 196, 222));
  m6.setArcThickness(10);
  
  m6.setMaxScaleValue(100);
  
  m6.setMinInputSignal(0);
  m6.setMaxInputSignal(100);
  m6.setNeedleThickness(2);
  
  
}

void draw(){
 //the title
 textSize(35);
 fill(255, 255, 255);//font color
 text("First box", 1000, 150);// ("text",x,y)
 
  textSize(35);
 fill(255, 255, 255);//font color
 text("Second box", 1000, 420);// ("text",x,y)
 
   textSize(35);
 fill(255, 255, 255);//font color
 text("Third box", 1000, 680);// ("text",x,y)
 
 
 
 if (port.available() >0){
   String val = port.readString(); //read incoming string
   //println(val);
   //we nedd to separate temperature and humidity values
   String[] list = split(val, ',');
   int temp = int(list[0]);
   int hum = int(list[1]);
   int temp2 = int(list[0]);
   int hum2 = int(list[1]);
   int temp3 = int(list[0]);
   int hum3 = int(list[1]);
   
   m.updateMeter(int(temp));
   m2.updateMeter(int(hum));
   m3.updateMeter(int(temp2));
   m4.updateMeter(int(hum2));
   m5.updateMeter(int(temp3));
   m6.updateMeter(int(hum3));
   
   println("Temperature: " + temp + "°C " + "Humidity:" + hum + "%");
 }
 delay(1500);
 }
